#include <map>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include "read_word.h"

using namespace std;

typedef map<string,unsigned> word_count_t;

void count_words(word_count_t& word_count)
{
   string word;
   while(read_word(word))
      word_count[word]++;
}

class count_cmp_t {
   const word_count_t& word_count;
public:
   bool operator()(const string *a,const string *b) {
      return word_count.at(*a) > word_count.at(*b);
   }
   count_cmp_t(const word_count_t& wc) : word_count(wc) {}
};

void print_top_words(const word_count_t& word_count,unsigned K)
{
   count_cmp_t count_cmp(word_count);
   vector<const string*> heap;
   for(word_count_t::const_iterator wc=word_count.begin(); wc!=word_count.end(); ++wc) {
      if(heap.size()>=K) {
	 const string *smallest_wc=heap.front();
	 if(word_count.at(*smallest_wc) > wc->second)
	    continue;
	 pop_heap(heap.begin(),heap.end(),count_cmp);
	 heap.pop_back();
      }
      heap.push_back(&wc->first);
      push_heap(heap.begin(),heap.end(),count_cmp);
   }
   sort_heap(heap.begin(),heap.end(),count_cmp);
   for(vector<const string*>::iterator word=heap.begin(); word!=heap.end(); ++word)
      cout << **word << '\t' << word_count.at(**word) << endl;
}

int main()
{
   cin.unsetf(ios_base::skipws);

   word_count_t word_count;
   count_words(word_count);

   print_top_words(word_count,100);

   return 0;
}
