#include <map>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <functional>
#include "read_word.h"

using namespace std;

typedef map<string,unsigned> word_count_t;
typedef pair<string,unsigned> wc_pair_t;

void count_words(word_count_t& word_count)
{
   string word;
   while(read_word(word))
      word_count[word]++;
}

struct count_cmp
{
   bool operator()(const wc_pair_t& a,const wc_pair_t& b) {
      return a.second > b.second;
   }
};

void print_top_words(const word_count_t& word_count,unsigned K)
{
   if(word_count.size()<K)
      K=word_count.size();

   vector<wc_pair_t> words(K);
   partial_sort_copy(word_count.begin(),word_count.end(),words.begin(),words.end(),count_cmp());

   for(vector<wc_pair_t>::iterator word=words.begin(); word!=words.end(); ++word)
      cout << word->first << '\t' << word->second << endl;
}

int main()
{
   cin.unsetf(ios_base::skipws);

   word_count_t word_count;
   count_words(word_count);

   print_top_words(word_count,100);

   return 0;
}
