#include <map>
#include <iostream>
#include <string>
#include "read_word.h"

using namespace std;

typedef map<string,unsigned> word_count_t;

void count_words(word_count_t& word_count)
{
   string word;
   while(read_word(word))
      word_count[word]++;
}

void print_top_words(const word_count_t& word_count,unsigned K)
{
   // use multimap with the count as the key, remove the smallest count if
   // there are too many words.
   typedef multimap<unsigned,const string*,greater<unsigned> > top_map_t;
   top_map_t top_map;
   for(word_count_t::const_iterator wc=word_count.begin(); wc!=word_count.end(); ++wc) {
      if(top_map.size()>=K) {
	 // if we have already K words, check if the next word has a better count.
	 top_map_t::iterator tail=top_map.end();
	 --tail;
	 if(tail->first > wc->second)
	    continue;
	 top_map.erase(tail);
      }
      top_map.insert(pair<unsigned,const string*>(wc->second,&wc->first));
   }
   for(top_map_t::iterator count=top_map.begin(); count!=top_map.end(); ++count)
      cout << *(count->second) << '\t' << count->first << endl;
}

int main()
{
   cin.unsetf(ios_base::skipws);

   word_count_t word_count;
   count_words(word_count);

   print_top_words(word_count,100);

   return 0;
}
